// ===============================================================
// UTPureRC5v.PureMajic: CRC checker....
// This works by using Webresonse.Includebinaryfile to load a file and pass it through sendbinary().
// the bytes can then be CRC checked...
// This object is used by both server and client.
// Include path not modified... otherwise, I would risk giving hackers space to hex edit :/
// ===============================================================

class PureMajic expands WebResponse;

var int zzCRC_Table[256];    //generated table for table-driven routine.
var bool zzbDidCRC; //if CRC called.
var int zzCurCRC; //CRC is held here as file is read and checksummed...
var int zzFileSize; //used for additional info
var bool zzFirstRead;
var string zzFileGUID;

//count is size or array (1-254)
//B represents each byte in the file.
//Send Binary is called filesize/255 times. (to send every byte in the file)
event SendBinary(int zzCount, byte zzB[255])
{
	local int zzn;
//	if (zzCount==255)
		zzbDidCRC = True;
	/* Update a running CRC with the bytes buf[0..count-1]--the CRC
	   should be initialized to all 1's, and the transmitted value
	   is the 1's complement of the final running CRC (see the
	   crc() routine below)). */
	zzFileSize += zzCount;

	for (zzn = 0; zzn < zzCount; zzn++)
	{
		zzCurCRC = zzCRC_Table[(zzCurCRC ^ zzB[zzn]) & 255] ^ (zzCurCRC >> 8);
	}
	zzCurCRC = zzCurCRC ^ 0xffffffff;

	if (zzFirstRead)
	{
				// 4 bytes (dword, reversed)
		zzFileGUID =	xxB2H(zzB[0x27])$xxB2H(zzB[0x26])$xxB2H(zzB[0x25])$xxB2H(zzB[0x24])$
				// 4 bytes (dword, reversed)
				xxB2H(zzB[0x2b])$xxB2H(zzB[0x2a])$xxB2H(zzB[0x29])$xxB2H(zzB[0x28])$
				// 4 bytes (dword, reversed)
				xxB2H(zzB[0x2f])$xxB2H(zzB[0x2e])$xxB2H(zzB[0x2d])$xxB2H(zzB[0x2c])$
				// 4 bytes (dword, reversed)
				xxB2H(zzB[0x33])$xxB2H(zzB[0x32])$xxB2H(zzB[0x31])$xxB2H(zzB[0x30]);
		zzFirstRead = False;
	}
}

function xxMake_CRC_Table()
{
	local int zzc;
	local int zzn, zzk;

	zzFirstRead = True;

	for (zzn = 0; zzn < 256; zzn++)
	{
		zzc = zzn;
		for (zzk = 0; zzk < 8; zzk++)
		{
			if ((zzc & 1) == 1)
				zzc = 0xedb88320 ^ (zzc >> 1);
			else
				zzc = zzc >> 1;
		}
		zzCRC_Table[zzn] = zzc;
	}
}

function string xxB2H(byte zzb)	// Byte to Hex
{
	return xxN2H(zzb / 0x10) $ xxN2H(zzb & 0xf);
}

function string xxN2H(byte zzn)	// Nibble to Hex
{
	if (zzn < 10)
		return chr(asc("0") + zzn);
	return chr(asc("A") + zzn - 10);
}

defaultproperties {
  IncludePath=""
}
